import subprocess
import os
import sys









; LCA Design=SB Part=2064PC68 -- Blocks=7 Nets=6.
; Program=APR Version=5.2.0-base Date=Sun Sep 23 22:44:59 2012.
; Speed File Version 2000.1 Revision 2064.6
Design 2064PC68
Speed -70
Programorder On

Addnet P2NET P2.I AB.B
Netdelay P2NET AB.B 5.8
NProgram AB.8.1.2 AB.8.1.4 AC.8.1.2 AC.8.1.7 AD.8.1.3 AD.8.1.7 col.B.local.2:AB.B row.A.local.2:PAD8.I

Addnet P3NET P3.I AB.D
Netdelay P3NET AB.D 4.3
NProgram BD.8.1.1 BD.8.1.7 BC.8.1.2 BC.8.1.7 row.B.local.1:AB.D col.D.local.2:PAD7.I

Addnet P4NET P4.I AB.C
Netdelay P4NET AB.C 2.8
NProgram AC.8.2.3 AC.8.2.7 col.B.local.5:AB.C row.A.local.4:PAD6.I col.B.local.5:row.A.local.3

Addnet P5NET P5.I AB.A
Netdelay P5NET AB.A 1.7
NProgram AC.8.2.4 AC.8.2.6 row.A.local.4:AB.A col.C.local.4:PAD5.I

Addnet P6NET AB.Y P6.O
Netdelay P6NET P6.O 0.4
NProgram col.C.local.5:AB.Y col.C.local.5:PAD4.O

Addnet P7NET AB.X P7.O
Netdelay P7NET P7.O 1.6
NProgram AC.8.1.4 AC.8.1.6 col.C.local.2:AB.X row.A.local.2:PAD3.O

Nameblk P2 P2IN
Editblk P2
    Base IO
    Config I:PAD BUF:
Endblk

Nameblk P3 P3IN
Editblk P3
    Base IO
    Config I:PAD BUF:
Endblk

Nameblk P4 P4IN
Editblk P4
    Base IO
    Config I:PAD BUF:
Endblk

Nameblk P5 P5IN
Editblk P5
    Base IO
    Config I:PAD BUF:
Endblk

Nameblk P6 P6OUT
Editblk P6
    Base IO
    Config I: BUF:ON
Endblk

Nameblk AA P7NET
Editblk AA
    Base FG
    Config F:B:C:Q G:B:C:Q X:F Y:G Q: RES:D SET:A CLK:
    Equate F = B*(C*Q)
    Equate G = B*(C*Q)
Endblk

Nameblk P7 P7OUT
Editblk P7
    Base IO
    Config I: BUF:ON
Endblk









def gen_clb_names():
    # "The format for CLB locations is two letters. The first letter indicates the row, the second letter indicates the column
    for row in [chr(ord('A') + i) for i in xrange(8)]:
        for col in [chr(ord('A') + i) for i in xrange(8)]:
            yield row + col


def init_clbs():
    global clbs
    clbs = {}
    for clb_name in gen_clb_names():
        # value doesn't matter so much as long as its fixed
        clbs[clb_name] = 0x0
init_clbs()

def canonical_sop_term(mask):
    def f(id, set):
        if set:
            return id
        else:
            return '(~%s)' % id
    if mask > 0xF:
        raise ValueError('4 variable max of 0xF')
    return f('A', mask & 1) + '*' + f('B', mask & 2) + '*' + f('C', mask & 4) + '*' + f('D', mask & 8)
    
def func(clb):
    # (~A*(~C*(~B*~D)))+((~A*(~C*(~B*D)))+((~A*(~C*(B*~D)))+((~A*(~C*(B*D)))+((~A*(C*(B*D)))+(A*(C*(B*D)))))))
    # Do non-canonical SOP
    print 'Generating for CLB 0x%04X' % clb
    if clb == 0:
        # Special case: make a contradiction
        return '((~A)*A)'
    ret = ''
    for i in xrange(16):
        mask = 1 << i
        if clb & mask:
            print 'Masked %d (bit position 0x%04X)' % (i, mask)
            if len(ret):
                ret += '+'
            ret += canonical_sop_term(i)
    return '(' + ret + ')'

def equate(which):
    return func(clbs[which])

from sweep_lca import *

def make(export_to):
    print 'Cleaning old output...'
    subprocess.check_call("make clean", shell=True)
    print 'Generating LCA...'
    lca = clb2lca(equate)
    print 'Writing LCA...'
    open('SBAPR.LCA', 'w').write(lca)
    print 'Synthesizing...'
    subprocess.check_call("make bits morebits", shell=True)
    print 'Saving result...'
    subprocess.check_call("./release.sh %s" % export_to, shell=True)

def loop_clb(clb_name, clb_config):
    export_to = 'CLB_%s_0x%04X' % (clb_name, clb_config)
    if os.path.exists(export_to):
        if g_overwrite:
            print 'WARNING: removing old dir %s' % export_to
            subprocess.check_call("rm -rf %s" % export_to, shell=True)
        else:
            print 'WARNING: skipping existing dir %s' % export_to
            return
    #print 'Tried synth on %s' % export_to
    #sys.exit(1)
    print
    print
    print
    print '****************************' 
    init_clbs()
    clbs[clb_name] = clb_config
    print 'Genearting %s w/ config 0x%04X (%s)' % (clb_name, clb_config, func(clb_config))
    make(export_to)
    #sys.exit(1)

g_overwrite = False
    
print
print
print
for clb_name in gen_clb_names():
    print
    print
    print
    print '****************************' 
    print 'Das CLB %s' % clb_name
    print '****************************' 
    print
    print
    loop_clb(clb_name, 0x0000)
    loop_clb(clb_name, 0xFFFF)
    # 4 variables => 16 bit memory required
    for clb_config in xrange(16):
        loop_clb(clb_name, 1 << clb_config)
